/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman 2003                                              *
 *                                                                            *
 *  This takes care of almost everything related to the engines input/output  *
 *  in a way defined in the CHESS ENGINE COMMUNICATION PROTOCOLL.             *
 *                                                                            *
 *  modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/

#ifndef ENGINE_H
#define ENGINE_H

#include <signal.h>
#include "iterate.h"
#include "openingbook.h"

#define CHECK_IF_THE_GAME_HAS_ENDED \
list = generateMoves(&(hoplite->game.currentPosition)); \
if (list->firstFree == 0) { \
  if (hoplite->game.currentPosition.isCheck) { \
    if (hoplite->game.currentPosition.whitesMove) \
      printf("0-1 {Black mates}\n"); \
    else printf ("1-0 {White mates}\n"); \
    fflush(stdout); \
  } else { \
    printf("1/2-1/2 {Stalemate}\n"); \
    fflush(stdout); \
  } \
  gameOver = TRUE; \
} else if (repeated3(&(hoplite->game))) { \
  printf("1/2-1/2 {Draw by repetition}\n"); \
  fflush(stdout); \
  gameOver = TRUE; \
} else if (insufficientMaterial(&(hoplite->game.currentPosition))) { \
  gameOver = TRUE; \
  printf("1/2-1/2 {Draw by insufficient material}\n"); \
  fflush(stdout); \
} else if (hoplite->game.currentPosition.movesSince > 100) { \
  printf("1/2-1/2 {Draw by 50 move rule}\n"); \
  fflush(stdout); \
  gameOver = TRUE; \
} \
freeMoveList(list); \


typedef struct {
  int protover;
  int go;
  int computerColor;
  int printThinkingOutput;
  double time_tc; // seconds
  double time_inc; // seconds
  int time_mps;
  double time_left; // seconds
  double time_left_opponent; // seconds
  TGame game;
} TEngine;


void initiallizeEngine(TEngine *engine);

void playInXboard();

void command_new(TEngine *engine);




#endif




