/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman 2003                                              *
 *                                                                            *
 *                                                                            *
 *  This file contains the game struct and functions to change it.     .      *
 *                                                                            *
 *  This should not need so much explanations if you have read position.h     *
 *                                                                            *
 *  The makeMove function is used to play moves. It makes the move, adds the  *
 *  position the the positions array, so that repetition detection can be     *
 *  performed later with repeated3 function, and calls evaluateCheck          *
 *  function. The positions array is an array of zobrist keys.                *
 *                                                                            *
 *  modified 15.3.2004                                                        *
 *                                                                            *
 *****************************************************************************/

#ifndef GAME_H
#define GAME_H

#define MAX_POSITIONS 120
#include "position.h"

typedef struct {
  TPosition currentPosition;
  zobristkey positions[MAX_POSITIONS];
  int firstFree;
} TGame;

typedef TGame *PGame;


void setStart(PGame game);

void addCurrent(PGame game); 

int repeated3(PGame game); // must be called before addCurrent

void makeMove(PGame game, PMove move);






#endif


