/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman 2003                                              *
 *                                                                            *
 *  Transposition table function implementations.                             *
 *                                                                            *
 *  modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/

#include "hash.h"

THashe hashTable[HASHTABLE_SIZE];

int probeHash(int depth, int alpha, int beta, zobristkey key, PMove move)
{
  PHashe test = &(hashTable[key % HASHTABLE_SIZE]);

  if (test->key == key && test->depth != -1) {
    if (test->depth >= depth) {      
      if (test->flags == HASH_EXACT)
        return test->value;
      if ((test->flags == HASH_ALPHA) && (test->value <= alpha))
        return alpha;
      if ((test->flags == HASH_BETA) && (test->value >= beta))
        return beta;
    }
    *move = test->bestMove;
  } else {
    move->promotion = 'F';
  }
  return HASH_UNKNOWN_VALUE;
}


void recordHash(int depth, int value, int hashFlag, zobristkey key, PMove move)
{
  PHashe recordHere = &(hashTable[key % HASHTABLE_SIZE]);

  if (depth > recordHere->depth) {
    recordHere->key = key;
    recordHere->bestMove = *move;
    recordHere->value = value; 
    recordHere->flags = hashFlag;
    recordHere->depth = depth;
  }
}


void clearHash()
{
  int i;
  for (i=0; i<HASHTABLE_SIZE; i++) {
    hashTable[i].depth = -1;
  }
}

