/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman 2003                                              *
 *                                                                            *
 *  History heuristics functions implementation.
 *                                                                            *
 *  modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/

#include "history.h"

PHistoryScore historyMoves[NUMBER_OF_HISTORYMOVE_TABLES];

void initiallizeHistoryMoves()
{
  int i;
  int x1, y1, x2, y2;

  for (i=0; i<NUMBER_OF_HISTORYMOVE_TABLES; i++) {
    historyMoves[i] = (PHistoryScore)malloc(sizeof(THistoryScore));
    for (x1=0; x1<8; x1++)
      for (y1=0; y1<8; y1++)
        for (x2=0; x2<8; x2++)
          for (y2=0; y2<8; y2++) {
            historyMoves[i]->scoreTable[x1][y1][x2][y2] = 0;
            historyMoves[i]->totalHits = 0;
          }
  }
}


void oneMoveMade()
{
  int i, x1, y1, x2, y2;
  
  free(historyMoves[0]);

  for (i=0; i<(NUMBER_OF_HISTORYMOVE_TABLES - 1); i++) 
    historyMoves[i] = historyMoves[i+1];

  historyMoves[NUMBER_OF_HISTORYMOVE_TABLES - 1] = 
    (PHistoryScore)malloc(sizeof(THistoryScore));

  for (x1=0; x1<8; x1++)
    for (y1=0; y1<8; y1++)
      for (x2=0; x2<8; x2++)
        for (y2=0; y2<8; y2++) {
          historyMoves[NUMBER_OF_HISTORYMOVE_TABLES-1] -> 
            scoreTable[x1][y1][x2][y2] = 0;
          historyMoves[NUMBER_OF_HISTORYMOVE_TABLES-1]->totalHits = 0;
        }
}


void addHistoryMove(PMove move, int ply)
{
  if (ply < NUMBER_OF_HISTORYMOVE_TABLES) {
    historyMoves[ply]->scoreTable[move->x1][move->y1][move->x2][move->y2] ++;
    historyMoves[ply]->totalHits++;
  }
}


unsigned int getMoveBonus(PMove move, int ply)
{
  int n;

  if (ply >= NUMBER_OF_HISTORYMOVE_TABLES) return 0;

  if (historyMoves[ply]->totalHits == 0) 
    return 0;

  n = historyMoves[ply]->scoreTable[move->x1][move->y1][move->x2][move->y2];
  return (n * 500000) / (historyMoves[ply]->totalHits);
}


void clearHistoryMoves()
{
  int i;
  int x1, y1, x2, y2;

  for (i=0; i<NUMBER_OF_HISTORYMOVE_TABLES; i++) {
    for (x1=0; x1<8; x1++)
      for (y1=0; y1<8; y1++)
        for (x2=0; x2<8; x2++)
          for (y2=0; y2<8; y2++) {
            historyMoves[i]->scoreTable[x1][y1][x2][y2] = 0;
            historyMoves[i]->totalHits = 0;
          }
  }
}







