/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman 2003                                              *
 *                                                                            *
 *  I have a 4d array, with coordinates for a move like this [x1][y1][x2][y2].*
 *  Now, every time when a move results in a beta cutoff, the value that      *
 *  corresponds to the move is increased by one.                              *
 *                                                                            *
 *  modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/

#ifndef HISTORY_H
#define HISTORY_H

#include "position.h"

#define NUMBER_OF_HISTORYMOVE_TABLES 30

typedef struct {
  /* [x1][y1][x2][y2] */
  unsigned int scoreTable[8][8][8][8];
  unsigned long long totalHits;
} THistoryScore;

typedef THistoryScore *PHistoryScore;

extern PHistoryScore historyMoves[NUMBER_OF_HISTORYMOVE_TABLES];

void initiallizeHistoryMoves();

void oneMoveMade();

void addHistoryMove(PMove move, int ply);

unsigned int getMoveBonus(PMove move, int ply);

void clearHistoryMoves();


#endif

