/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman                                                   *
 *                                                                            *
 *  With the iterative search we can search a position starting from depth 1  *
 *  and contine until we are out of time.                                     *
 *                                                                            *
 *  I use the principal variation line, killermoves, history heuristics and   *
 *  hashtables from the previous iteration to speed up the search.            *
 *                                                                            *
 *  I call the search with a window of 1 pawn (previous_value +- 0.5pawn).    *
 *  This is done by setting alpha = previous_value - 0.5 pawns and            *
 *  beta = previous_value + 0.5 pawns. This should be faster, but If the      *
 *  search fails, we have to search again. With good luck the hashtables are  *
 *  full of usefull information, so everything is not wasted.                 *
 *                                                                            *
 *  modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/

#ifndef ITERATE_H
#define ITERATE_H

#include "search.h"

#define WINDOW_WIDTH 500

TMove iterate(PGame game, double minTime, double maxTime);

void printPVLine(PGame game, int depth, int score, TLine *pv);


#endif


