/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman 2003                                              *
 *                                                                            *
 *  Killermove function implementations.
 *                                                                            *
 *  Modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/


#include "killermoves.h"

TMove killerMoves0[KILLER_MOVES_IN_USE];
TMove killerMoves1[KILLER_MOVES_IN_USE];
int lastKillerMove[KILLER_MOVES_IN_USE];

void addKillerMove(PMove move, int ply)
{
  if (move_equals(move, killerMoves0+ply)) {
    lastKillerMove[ply] = 0;
    return;
  }
  if (move_equals(move, killerMoves1+ply)) {
    lastKillerMove[ply] = 1;
    return;
  }
  if (lastKillerMove[ply] == 0) {
    killerMoves1[ply] = *move;
    lastKillerMove[ply] = 1;
    return; 
  }
  if (lastKillerMove[ply] == 1) {
    killerMoves0[ply] = *move;
    lastKillerMove[ply] = 0;
    return; 
  }        
}


void clearKillerMoves(void)
{
  int i;
  for (i=0; i<KILLER_MOVES_IN_USE; i++) {
    killerMoves0[i].promotion = 'F';
    killerMoves1[i].promotion = 'F';
    lastKillerMove[i] = 1;
  }
}









