/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman 2003                                              *
 *                                                                            *
 *  Killermoves are used in Hoplite in such a way that the 2 best moves at    *
 *  each ply are stored in arrays. Allways when a move results in a beta      *
 *  cutoff, it will be stored to one of the killermoves array. The only       *
 *  exception is when the move allready is there. We remember a value         *
 *  lastKillerMove, so that we allways write over the oldest killermove.      *
 *                                                                            *
 *  Modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/


#ifndef KILLERMOVES_H
#define KILLERMOVES_H

#include "position.h"

#define KILLER_MOVES_IN_USE 100

extern TMove killerMoves0[KILLER_MOVES_IN_USE];
extern TMove killerMoves1[KILLER_MOVES_IN_USE];
extern int lastKillerMove[KILLER_MOVES_IN_USE];

void addKillerMove(PMove move, int ply);

void clearKillerMoves(void);

#endif







