/******************************************************************************
 *                                                                            *
 *  Hoplite (c) Frans Ekman                                                   *
 *                                                                            *
 *  The opening book function implementation.                                 *
 *                                                                            *
 *  modified 24.2.2004                                                        *
 *                                                                            *
 *****************************************************************************/

#include "openingbook.h"

PMemPos openings[MAX_POSITIONS_IN_MEMORY];

PMove getMoveFromOpenings(PGame game)
{
  int i;
  int index;
  for (i=0; i<MAX_POSITIONS_IN_MEMORY; i++) {
    if (openings[i] == NULL) return NULL;
    if (equals(openings[i]->position, &(game->currentPosition))) {
      if (openings[i]->numberOfMoves > 1) 
        index = ((unsigned int)rand()) % openings[i]->numberOfMoves;
      else index = 0;
      return openings[i]->moves[index];
    }
  }
  return NULL;
}


void initiallize_openings()
{
  int i, j;
  char *buffer;
  char c;
  FILE *file = fopen("openings.001", "r");
  buffer = (char *)malloc(sizeof(char) * 255);
  for (i=0; i<MAX_POSITIONS_IN_MEMORY; i++) {
    openings[i] = NULL;
  }
  i = 0;
  while (1) {
    openings[i] = (PMemPos)malloc(sizeof(struct TMemPos));
    openings[i]->position = (PPosition)malloc(sizeof(TPosition));
    openings[i]->numberOfMoves = 0;
    j = 0;
    while (1) {
      c = getc(file);
      if (c == '#') break; 
      buffer[j] = c;
      j++;
    }
    buffer[j+1] = '\0';
    setPosition(openings[i]->position, buffer);
    j = 0;
    while (j<10) {
      fscanf(file, "%s", buffer);
      if (buffer[0] == '#') break;
      openings[i]->moves[j] = createMove(openings[i]->position, buffer);
      openings[i]->numberOfMoves++;
      j++;
    }
    c = getc(file);
    if (c == '!' || c == EOF) break;
    i++;
  }
  free(buffer);
  fclose(file);
}
